<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<?php 
	/* 
	 * vStar Online v1.0 
	 * Search American Association of Variable Star Observers (AAVSO) data by coordinates, constellation, and light curve criteria.
	 * This data was gerated by the American Association of Variable Star Observers http://www.aavso.org/
	 *
	 * Created by Rick Burton - Data Pathways 01/28/2013
	 * rick.burton@datapathways.com http://astronomy.datapathways.com
	 */
?>

<head>
	<title>v* vStar Online [AAVSO Variable Star Search]</title>
	<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
	<meta name="description" content="vStar Online v1.0 AAVSO Variable Star Search"/>
	<meta name="keywords" content="Variable Stars, Search, AAVSO"/>
	<meta name="author" content="Rick Burton"/>
	<meta name="date" content="01/25/2013"/>
	<meta name="company" content="http://www.datapathways.com"/>
	<script type="text/javascript">

		// Retains form values after search is submitted
		// Function code is only created upon form submit
		function setParms()
		{
		<?php if(isset($_REQUEST['form_action'])) { ?>
			var frm = document.searchfrm;

			frm.magnitude.checked = <?php print ($_REQUEST['magnitude'] == 'on' ? 'true' : 'false'); ?>;
			frm.period.checked    = <?php print ($_REQUEST['period']    == 'on' ? 'true' : 'false'); ?>;
			frm.no_curve.checked  = <?php print ($_REQUEST['no_curve']  == 'on' ? 'true' : 'false'); ?>;

			frm.ra_hours_west.value      = "<?php print $_REQUEST['ra_hours_west']; ?>";
			frm.ra_hours_east.value      = "<?php print $_REQUEST['ra_hours_east']; ?>";
			frm.south_dec_sign.value     = "<?php print $_REQUEST['south_dec_sign']; ?>";
			frm.south_degrees_tens.value = "<?php print $_REQUEST['south_degrees_tens']; ?>";
			frm.south_degrees_ones.value = "<?php print $_REQUEST['south_degrees_ones']; ?>";
			frm.north_dec_sign.value     = "<?php print $_REQUEST['north_dec_sign']; ?>";
			frm.north_degrees_tens.value = "<?php print $_REQUEST['north_degrees_tens']; ?>";
			frm.north_degrees_ones.value = "<?php print $_REQUEST['north_degrees_ones']; ?>";
			frm.constellation.value      = "<?php print $_REQUEST['constellation']; ?>";

			if(frm.constellation.value != "")
				setLoc(true);

			frm.min_mag.value     = "<?php print $_REQUEST['min_mag']; ?>";
			frm.min_delta.value   = "<?php print $_REQUEST['min_delta']; ?>";
			frm.min_per.value     = "<?php print $_REQUEST['min_per']; ?>";
			frm.max_per.value     = "<?php print $_REQUEST['max_per']; ?>";

			if(!frm.magnitude.checked)
				setMag(true);
			if(!frm.period.checked)
				setPer(true);
			if(frm.no_curve.checked)
			{
				setMag(true);
				setPer(true);
				frm.magnitude.disabled = true;
				frm.period.disabled    = true;
				document.getElementById("magchkfnt").style.color = "#c0c0c0";
				document.getElementById("perchkfnt").style.color = "#c0c0c0";
			}
		<?php } ?>
			return 0;
		}

		// Currently unused
		function resetPage()
		{
			window.location = "search.php";
		}

		// Event handler for enable/disable coordinates controls
		function setLocCtrls(me)
		{
			if(me.value == "")
				setLoc(false);
			else
				setLoc(true);
		}

		// Enable/disable coordinates controls
		function setLoc(disable)
		{
			var frm = document.searchfrm;

			frm.ra_hours_west.disabled      = disable;
			frm.ra_hours_east.disabled      = disable;
			frm.south_dec_sign.disabled     = disable;
			frm.south_degrees_tens.disabled = disable;
			frm.south_degrees_ones.disabled = disable;
			frm.north_dec_sign.disabled     = disable;
			frm.north_degrees_tens.disabled = disable;
			frm.north_degrees_ones.disabled = disable;

			// Gray the text when controls are disabled
			document.getElementById("locfnt").style.color = (disable ? "#c0c0c0" : "#00ff00");
		}

		// Event handler for enable/disable light curve controls
		function setCurveCtrls(me, ctrls)
		{
			var box = me.name;
			var chkd = me.checked;
			var frm = document.searchfrm;

			if(box == "magnitude")
			{
				setMag(!chkd);
			}
			else if(box == "period")
			{
				setPer(!chkd);
			}
			else if(box == "no_curve")
			{
				frm.magnitude.disabled = chkd;
				frm.period.disabled    = chkd;
				setMag(chkd ? true : !frm.magnitude.checked);
				setPer(chkd ? true : !frm.period.checked);
				// Gray the text when controls are disabled
				document.getElementById("magchkfnt").style.color = (chkd ? "#c0c0c0" : "#00ff00");
				document.getElementById("perchkfnt").style.color = (chkd ? "#c0c0c0" : "#00ff00");
			}
			else
			{
				alert("Search control error");
			}
		}

		// Enable/disable magnitude controls
		function setMag(disable)
		{
			document.searchfrm.min_mag.disabled   = disable;
			document.searchfrm.min_delta.disabled = disable;
			// Gray the text when controls are disabled
			document.getElementById("magfnt").style.color = (disable ? "#c0c0c0" : "#00ff00");
		}

		// Enable/disable period controls
		function setPer(disable)
		{
			document.searchfrm.min_per.disabled = disable;
			document.searchfrm.max_per.disabled = disable;
			// Gray the text when controls are disabled
			document.getElementById("perfnt").style.color = (disable ? "#c0c0c0" : "#00ff00");
		}

		// Check maximum period value to minimum, correct if necessary
		function checkMaxPer(me)
		{
			var elem = document.searchfrm.max_per;
			var max_val = elem.value-0;

			if(max_val < me.value-0)
				elem.value = 1000;
		}

		// Check minimum period value to minimum, correct if necessary
		function checkMinPer(me)
		{
			var elem = document.searchfrm.min_per;
			var min_val = elem.value-0;

			if(min_val > me.value-0)
				elem.value = 0;
		}

	</script>
	<style type="text/css">
		/* General page-wide element style section */
		BODY
		{
			font-family: 'Courier Regular', 'Courier New', 'Courier 10 Pitch', monospace;
			font-weight: bold;
			color: #0f0;
			background: #002;
		}
		A
		{
			font-family: 'Courier Regular', 'Courier New', 'Courier 10 Pitch', monospace;
			font-weight: bold;
			color: #09f;
			background: transparent;
			text-decoration: none;
		}
		A:hover
		{
			color: #fff;
			background: #69c;
			text-decoration: none;
		}
		SELECT
		{
			margin: 0px;
			padding: 0px;
			font-size: 11px;
			line-height: 13px;			
		}
		OPTION
		{
			margin: 0px;
			padding: 0px;
			font-size: 11px;
			line-height: 13px;			
		}
		BUTTON
		{
			font-size: 11px;
			line-height: 13px;
		}

		/* Main Content Container */
		DIV.container
		{
			margin-left:auto; margin-right:auto; /* centered */
			width:980px; position:relative;
		}

		/* Title Section */
		DIV.title
		{
			color:#eee; background:transparent; 
			font-family:sans-serif; font-weight:bold; 
			font-size:24px; line-height:24px;
			position:absolute;
			top:6px; left:7px;
		}
		DIV.title2 /* drop shadow */
		{
			color:#33e; background:transparent; 
			font-family:sans-serif; font-weight:bold; 
			font-size:24px; line-height:24px;
			position:absolute;
			top:4px; left:4px;
			z-index:-1;
		}

		/* Virtual Monitor Section */
		DIV.searchCtrl, DIV.search
		{
			font-size: 11px;
			line-height: 13px;
		}
		DIV.searchCtrl /* Upper section of monitor containing controls */
		{
			border-left:6px solid gray; border-top:6px solid gray; 
			border-right:6px solid silver; 
			padding:8px 8px 0px 8px; width:950px; height:281px;
			position:absolute; top:40px;
			color:#0f0; background:#000;
		}
		DIV.search /* Lower section of monitor containing search results */
		{
			border-left:6px solid gray;
			border-right:6px solid silver; border-bottom:6px solid silver; 
			padding:0px 8px 8px 8px; width:950px;
			position:absolute; margin-top:335px;
			color:#0f0; background:#000;
			height:291px; overflow:auto; /* scrollable when needed */
		}

	</style>
	<link rel="shortcut icon" type="image/ico" href="/OtherWorld.ico"/>
</head>

<body class="search" onload="setParms(); printNum();">
<div class="container">

	<!-- Drop shadow title -->
	<div class="title">
		<font>&nbsp;v* - vStar [AAVSO Variable Star Search]&nbsp;</font>
	</div>
	<div class="title2">
		<font>&nbsp;v* - vStar [AAVSO Variable Star Search]&nbsp;</font>
	</div>
	<div class="searchCtrl">

	<!-- MENU Section - not wrapped to avoid extra padding between items in rendering -->
	<a href="/index.php">&nbsp;Home&nbsp;</a>|<a href="/astroblog.php">&nbsp;Astro Blog&nbsp;</a>|<a href="/astrogallery.php">&nbsp;Astro Gallery&nbsp;</a>|<a href="/vstar.php">&nbsp;vStar Download&nbsp;</a>|<a href="/concepts/WDS/search.php">&nbsp;Double Star Search&nbsp;</a>|<a href="Users_Guide.html" target="_blank">&nbsp;HELP&nbsp;</a>
	<br/><br/>
	<form name="searchfrm" method="post" action="search.php">
		<font id="locfnt">
		<!-- West R.A. hour -->
		<select name="ra_hours_west">
			<option selected="selected" value="00">00</option>
			<option value="01">01</option>
			<option value="02">02</option>
			<option value="03">03</option>
			<option value="04">04</option>
			<option value="05">05</option>
			<option value="06">06</option>
			<option value="07">07</option>
			<option value="08">08</option>
			<option value="09">09</option>
			<option value="10">10</option>
			<option value="11">11</option>
			<option value="12">12</option>
			<option value="13">13</option>
			<option value="14">14</option>
			<option value="15">15</option>
			<option value="16">16</option>
			<option value="17">17</option>
			<option value="18">18</option>
			<option value="19">19</option>
			<option value="20">20</option>
			<option value="21">21</option>
			<option value="22">22</option>
			<option value="23">23</option>
		</select> Hr R.A. West Limit
		<!-- East R.A. Hour -->
		<select name="ra_hours_east">
			<option value="00">00</option>
			<option value="01">01</option>
			<option value="02">02</option>
			<option value="03">03</option>
			<option value="04">04</option>
			<option value="05">05</option>
			<option value="06">06</option>
			<option value="07">07</option>
			<option value="08">08</option>
			<option value="09">09</option>
			<option value="10">10</option>
			<option value="11">11</option>
			<option value="12">12</option>
			<option value="13">13</option>
			<option value="14">14</option>
			<option value="15">15</option>
			<option value="16">16</option>
			<option value="17">17</option>
			<option value="18">18</option>
			<option value="19">19</option>
			<option value="20">20</option>
			<option value="21">21</option>
			<option value="22">22</option>
			<option selected="selected" value="23">23</option>
		</select> Hr R.A. East Limit
		<br/>

		<!-- North Declination Limit -->
		<!-- N/S sign -->
		<select name="south_dec_sign">
			<option value="+">+</option>
			<option selected="selected" value="-">-</option>
		</select> 
		<!-- 10s of degrees -->
		<select name="south_degrees_tens">
			<option value="0">00</option>
			<option value="1">10</option>
			<option value="2">20</option>
			<option value="3">30</option>
			<option value="4">40</option>
			<option value="5">50</option>
			<option value="6">60</option>
			<option value="7">70</option>
			<option value="8">80</option>
			<option selected="selected" value="9">90</option>
		</select> 10s
		<!-- Single degrees -->
		<select name="south_degrees_ones">
			<option selected="selected" value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
		</select> 1s - Deg South Limit


		<!-- South Declination Limit -->
		<!-- N/S sign -->
		<select name="north_dec_sign">
			<option value="+">+</option>
			<option value="-">-</option>
		</select> 
		<!-- 10s of degrees -->
		<select name="north_degrees_tens">
			<option value="0">00</option>
			<option value="1">10</option>
			<option value="2">20</option>
			<option value="3">30</option>
			<option value="4">40</option>
			<option value="5">50</option>
			<option value="6">60</option>
			<option value="7">70</option>
			<option value="8">80</option>
			<option selected="selected" value="9">90</option>
		</select> 10s
		<!-- Single degrees -->
		<select name="north_degrees_ones">
			<option selected="selected" value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
		</select> 1s - Deg North Limit
		<br/>
		</font>
		<br/>

		<!-- Constellations -->
		<select name="constellation" onchange="setLocCtrls(this);">
			<option selected="selected" value="">[Select]</option>
			<option value="And">Andromeda</option>
			<option value="Ant">Antlia</option>
			<option value="Aps">Apus</option>
			<option value="Aqr">Aquarius</option>
			<option value="Aql">Aquila</option>
			<option value="Ara">Ara</option>
			<option value="Ari">Aries</option>
			<option value="Aur">Auriga</option>
			<option value="Boo">Bootes</option>
			<option value="Cae">Caelum</option>
			<option value="Cam">Camelopardalis</option>
			<option value="Cnc">Cancer</option>
			<option value="CVn">Canes Venatici</option>
			<option value="CMa">Canis Major</option>
			<option value="CMi">Canis Minor</option>
			<option value="Cap">Capricornus</option>
			<option value="Car">Carina</option>
			<option value="Cas">Cassiopeia</option>
			<option value="Cen">Centaurus</option>
			<option value="Cep">Cepheus</option>
			<option value="Cet">Cetus</option>
			<option value="Cha">Chamaeleon</option>
			<option value="Cir">Circinus</option>
			<option value="Col">Columba</option>
			<option value="Com">Coma Berenices</option>
			<option value="CrA">Corona Australis</option>
			<option value="CrB">Corona Borealis</option>
			<option value="Crv">Corvus</option>
			<option value="Crt">Crater</option>
			<option value="Cru">Crux</option>
			<option value="Cyg">Cygnus</option>
			<option value="Del">Delphinus</option>
			<option value="Dor">Dorado</option>
			<option value="Dra">Draco</option>
			<option value="Eql">Equuleus</option>
			<option value="Eri">Eridanus</option>
			<option value="For">Fornax</option>
			<option value="Gem">Gemini</option>
			<option value="Gru">Grus</option>
			<option value="Her">Hercules</option>
			<option value="Hor">Horologium</option>
			<option value="Hya">Hydra</option>
			<option value="Hyi">Hydrus</option>
			<option value="Ind">Indus</option>
			<option value="Lac">Lacerta</option>
			<option value="Leo">Leo</option>
			<option value="LMi">Leo Minor</option>
			<option value="Lep">Lepus</option>
			<option value="Lib">Libra</option>
			<option value="Lup">Lupus</option>
			<option value="Lyn">Lynx</option>
			<option value="Lyr">Lyra</option>
			<option value="Men">Mensa</option>
			<option value="Mic">Microscopium</option>
			<option value="Mon">Monoceros</option>
			<option value="Mus">Musca</option>
			<option value="Nor">Norma</option>
			<option value="Oct">Octans</option>
			<option value="Oph">Ophiuchus</option>
			<option value="Ori">Orion</option>
			<option value="Pav">Pavo</option>
			<option value="Peg">Pegasus</option>
			<option value="Per">Perseus</option>
			<option value="Phe">Phoenix</option>
			<option value="Pic">Pictor</option>
			<option value="Psc">Pisces</option>
			<option value="PsA">Piscis Austrinus</option>
			<option value="Pup">Puppis</option>
			<option value="Pyx">Pyxis</option>
			<option value="Ret">Reticulum</option>
			<option value="Sge">Sagitta</option>
			<option value="Sgr">Sagittarius</option>
			<option value="Sco">Scorpius</option>
			<option value="Scl">Sculptor</option>
			<option value="Sct">Scutum</option>
			<option value="Ser">Serpens</option>
			<option value="Sex">Sextans</option>
			<option value="Tau">Taurus</option>
			<option value="Tel">Telescopium</option>
			<option value="Tri">Triangulum</option>
			<option value="TrA">Triangulum Australe</option>
			<option value="Tuc">Tucana</option>
			<option value="UMa">Ursa Major</option>
			<option value="UMi">Ursa Minor</option>
			<option value="Vel">Vela</option>
			<option value="Vir">Virgo</option>
			<option value="Vol">Volans</option>
			<option value="Vul">Vulpecula</option>
		</select> Constellation
		<br/>___________________________________________________________________________________________________________________________________<br/>

		<font id="magchkfnt">
		<!-- Magnitude limit -->
		<input type="checkbox" name="magnitude" checked="checked" onclick="setCurveCtrls(this,'mag');"/>Magnitude 
		</font>
		<font id="magfnt">
		<select name="min_mag">
			<option value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option selected="selected" value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
			<option value="10">10</option>
			<option value="15">15</option>
			<option value="20">20</option>
			<option value="25">25</option>
		</select> Max &gt; 
		<!-- Delta limit -->
		<select name="min_delta">
			<option selected="selected" value="0">0</option>
			<option value="0.5">0.5</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
			<option value="10">10</option>
			<option value="15">15</option>
			<option value="20">20</option>
			<option value="25">25</option>
		</select> Delta &gt; 
		<br/>
		</font>
		<font id="perchkfnt">
		<input type="checkbox" name="period" checked="checked" onclick="setCurveCtrls(this,'per');"/>Period
		</font>
		<font id="perfnt">

		<!-- Period lower limit -->
		<select name="min_per" onchange="checkMaxPer(this);">
			<option selected="selected" value="0">0</option>
			<option value="1">1</option>
			<option value="7">7</option>
			<option value="30">30</option>
			<option value="90">90</option>
			<option value="180">180</option>
			<option value="360">360</option>
			<option value="1000">1,000</option>
		</select> Least 
		<!-- Period upper limit -->
		<select name="max_per" onchange="checkMinPer(this);">
			<option value="1">1</option>
			<option value="7">7</option>
			<option value="30">30</option>
			<option value="90">90</option>
			<option value="180">180</option>
			<option value="360">360</option>
			<option selected="selected" value="1000">1,000</option>
			<option value="10000">10,000</option>
		</select> Most 
		<br/>
		</font>
		<br/>
		<input type="checkbox" name="no_curve" onclick="setCurveCtrls(this,'both');"/>No Light Curve
		<br/>
		<input type="hidden" name="form_action" value="search"/><br/>
	</form>
	<button name="searchbtn" onclick="document.searchfrm.submit();">Search</button>
	<button name="resetbtn" onclick="document.searchfrm.reset();window.location='search.php';">Reset</button>
	<button name="helpbtn" onclick="window.open('Users_Guide.html');">HELP</button>&nbsp;

<?php
	main();
	// Used similar to C style main()
	function main()
	{
		global $output; // Contains formatted records
		global $curr;   // Array for output formatting - current characters 
		global $repl;   // Array for output formatting - replacement strings
		global $num_results; // Counts number of records found
	
		// Set variables' values
		$output = '';
		$curr = array(" ", "\n", "\t");
		$repl = array("&nbsp;", "<br/> ", "&nbsp;&nbsp;&nbsp;&nbsp;");
		$num_results = 0;
		// Check for submitted search form
		$search = isset($_REQUEST['form_action']) && $_REQUEST['form_action'] === 'search';

		$header = '
RA  Dec    Name        Type       Range         Period   Description          
___________________________________________________________________________________________________________________________________

	';
		// Search form is submitted, first create a span for result count
		if($search)
			print '<font color="red"><span id="num_results">Searching...</span></font>
			';

		print '<br/>';
		print str_replace($curr, $repl, $header); // Relace each space character with HTML &nbsp;
		print '</div>';
		print '<div class="search">';

		if($search)
		{
			// Open the data file here	
			$handle = @fopen("vallongtype.txt", "r");
			if ($handle) 
			{
				// Read the data file until there's no more to read
				while (($buffer = fgets($handle, 4096)) !== false) 
				{
					$print = false;
					// Location Search parameters
					// ----------------------------------------------------------------------------------------------------------
					if(isset($_REQUEST['ra_hours_west'])) // This indicates that coordinates search is active
					{
						$not_reverse = ($_REQUEST['ra_hours_west'] <= $_REQUEST['ra_hours_east']);

						if($not_reverse)
						{
							$print = 
								substr($buffer, 0, 2) >= $_REQUEST['ra_hours_west'] && 
								substr($buffer, 0, 2) <= $_REQUEST['ra_hours_east']; 
						}
						else
						{
							$print = 
								substr($buffer, 0, 2) >= $_REQUEST['ra_hours_west'] || 
								substr($buffer, 0, 2) <= $_REQUEST['ra_hours_east']; 
						}

						$print = $print && (
							substr($buffer, 4, 3) >= ($_REQUEST['south_dec_sign'].
								$_REQUEST['south_degrees_tens'].$_REQUEST['south_degrees_ones']) &&
							substr($buffer, 4, 3) <= ($_REQUEST['north_dec_sign'].
								$_REQUEST['north_degrees_tens'].$_REQUEST['north_degrees_ones']) );
					}

					if($_REQUEST['constellation'] !== '') // This indicates that constellation search is active
						$print = substr(trim(substr($buffer, 10, 12)), -3) === strtoupper($_REQUEST['constellation']);

					// Light Curve parameters
					// ----------------------------------------------------------------------------------------------------------
					if($print && isset($_REQUEST['magnitude']))
					{
						if(trim(substr($buffer, 40, 5)) != '')
							$print = 
								trim(substr($buffer, 33, 5)) <= $_REQUEST['min_mag'] &&
								trim(substr($buffer, 40, 5)) - trim(substr($buffer, 33, 5)) >= 
									$_REQUEST['min_delta'];
						else
							$print = false;
					}

					if($print && isset($_REQUEST['period']))
					{
						if(trim(substr($buffer, 46, 9)) != '')
							$print = 
								trim(substr($buffer, 46, 9)) >= $_REQUEST['min_per'] &&
								trim(substr($buffer, 46, 9)) <= $_REQUEST['max_per'];
						else 
							$print = false;
					}

					// No Curve data specified
					// ----------------------------------------------------------------------------------------------------------
					if($print && isset($_REQUEST['no_curve']))
						$print = trim(substr($buffer, 33, 22)) == "";

					if($print)
					{
						// The line below inserts one space after the 7-character identifier 
						// and another between the period and description fields
						$buffer = substr($buffer, 0, 7).' '.substr($buffer, 7, 48).' '.substr($buffer, 55, strlen($buffer)-55);
						$output = str_replace($curr, $repl, $buffer);
						print '<font color="white">'.substr($output, 0, 7).'</font>'.substr($output, 7, -1);
						$num_results++;
					}
				}

				if (!feof($handle)) 
				{
					echo "Error: unexpected fgets() fail\n";
				}
		
				fclose($handle);
			}
		}
		// This is our virtual cursor for the virtual monitor
		print '<font style="font-weight:bold; text-decoration:blink;">_</font>';
	}

?>
	<script type="text/javascript">
		// Display number of records found - called by BODY onload event
		function printNum() 
		{ 
			document.getElementById("num_results").innerHTML = "Records Found: <?php print $num_results; ?>"; 
		}
	</script>

	</div>
</div>
</body>
</html>


